# Quick Start
Exposing the service requires passing the `-p` flag to expose ports from the container

---

#### Running a container from a Docker image

```bash
$ rio run -p 80 --name demo nginx

# You will get an endpoint URL for your service
$ rio ps

# Access endpoint URL
curl https://demo-v0-default.xxxxx.on-rio.io
```

#### Running a container from a GitHub repository
Rio allows a user to run a container directly from source code. 
By pointing to git repository that contains a Dockerfile, Rio will clone the source code, build the Docker image, and deploy it into the cluster.
Also Rio will watch for changes to the repo and automatically update the deployment.

```bash
$ rio run -p 8080 --name demo-2 https://github.com/rancher/rio-demo

# You will get an endpoint URL for your service
$ rio ps

# Access endpoint URL
curl https://demo-2-v0-default.xxxxx.on-rio.io
```

---

For more advanced use cases, check [Running workload in Rio](./workloads.md)
