/*
Copyright 2020 Rancher Labs.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by main. DO NOT EDIT.

package fake

import (
	adminriocattleiov1 "github.com/rancher/rio/pkg/apis/admin.rio.cattle.io/v1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakePublicDomains implements PublicDomainInterface
type FakePublicDomains struct {
	Fake *FakeAdminV1
}

var publicdomainsResource = schema.GroupVersionResource{Group: "admin.rio.cattle.io", Version: "v1", Resource: "publicdomains"}

var publicdomainsKind = schema.GroupVersionKind{Group: "admin.rio.cattle.io", Version: "v1", Kind: "PublicDomain"}

// Get takes name of the publicDomain, and returns the corresponding publicDomain object, and an error if there is any.
func (c *FakePublicDomains) Get(name string, options v1.GetOptions) (result *adminriocattleiov1.PublicDomain, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootGetAction(publicdomainsResource, name), &adminriocattleiov1.PublicDomain{})
	if obj == nil {
		return nil, err
	}
	return obj.(*adminriocattleiov1.PublicDomain), err
}

// List takes label and field selectors, and returns the list of PublicDomains that match those selectors.
func (c *FakePublicDomains) List(opts v1.ListOptions) (result *adminriocattleiov1.PublicDomainList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootListAction(publicdomainsResource, publicdomainsKind, opts), &adminriocattleiov1.PublicDomainList{})
	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &adminriocattleiov1.PublicDomainList{ListMeta: obj.(*adminriocattleiov1.PublicDomainList).ListMeta}
	for _, item := range obj.(*adminriocattleiov1.PublicDomainList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested publicDomains.
func (c *FakePublicDomains) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewRootWatchAction(publicdomainsResource, opts))
}

// Create takes the representation of a publicDomain and creates it.  Returns the server's representation of the publicDomain, and an error, if there is any.
func (c *FakePublicDomains) Create(publicDomain *adminriocattleiov1.PublicDomain) (result *adminriocattleiov1.PublicDomain, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootCreateAction(publicdomainsResource, publicDomain), &adminriocattleiov1.PublicDomain{})
	if obj == nil {
		return nil, err
	}
	return obj.(*adminriocattleiov1.PublicDomain), err
}

// Update takes the representation of a publicDomain and updates it. Returns the server's representation of the publicDomain, and an error, if there is any.
func (c *FakePublicDomains) Update(publicDomain *adminriocattleiov1.PublicDomain) (result *adminriocattleiov1.PublicDomain, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateAction(publicdomainsResource, publicDomain), &adminriocattleiov1.PublicDomain{})
	if obj == nil {
		return nil, err
	}
	return obj.(*adminriocattleiov1.PublicDomain), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakePublicDomains) UpdateStatus(publicDomain *adminriocattleiov1.PublicDomain) (*adminriocattleiov1.PublicDomain, error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateSubresourceAction(publicdomainsResource, "status", publicDomain), &adminriocattleiov1.PublicDomain{})
	if obj == nil {
		return nil, err
	}
	return obj.(*adminriocattleiov1.PublicDomain), err
}

// Delete takes name of the publicDomain and deletes it. Returns an error if one occurs.
func (c *FakePublicDomains) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewRootDeleteAction(publicdomainsResource, name), &adminriocattleiov1.PublicDomain{})
	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakePublicDomains) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewRootDeleteCollectionAction(publicdomainsResource, listOptions)

	_, err := c.Fake.Invokes(action, &adminriocattleiov1.PublicDomainList{})
	return err
}

// Patch applies the patch and returns the patched publicDomain.
func (c *FakePublicDomains) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *adminriocattleiov1.PublicDomain, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootPatchSubresourceAction(publicdomainsResource, name, pt, data, subresources...), &adminriocattleiov1.PublicDomain{})
	if obj == nil {
		return nil, err
	}
	return obj.(*adminriocattleiov1.PublicDomain), err
}
