// Code generated by protoc-gen-gogo. DO NOT EDIT.
// source: github.com/solo-io/gloo/projects/gloo/api/v1/options/headers/headers.proto

package headers

import (
	bytes "bytes"
	fmt "fmt"
	math "math"

	_ "github.com/gogo/protobuf/gogoproto"
	proto "github.com/gogo/protobuf/proto"
	types "github.com/gogo/protobuf/types"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.GoGoProtoPackageIsVersion3 // please upgrade the proto package

// This plugin provides configuration options to append and remove headers from
// requests and responses
// HeaderManipulation can be specified on routes, virtual hosts, or weighted destinations
type HeaderManipulation struct {
	// Specifies a list of HTTP headers that should be added to each request
	// handled by this route or virtual host. For more information, including
	// details on header value syntax, see the
	// [Envoy documentation](https://www.envoyproxy.io/docs/envoy/latest/configuration/http_conn_man/headers#config-http-conn-man-headers-custom-request-headers) .
	RequestHeadersToAdd []*HeaderValueOption `protobuf:"bytes,1,rep,name=request_headers_to_add,json=requestHeadersToAdd,proto3" json:"request_headers_to_add,omitempty"`
	// Specifies a list of HTTP headers that should be removed from each request
	// handled by this route or virtual host.
	RequestHeadersToRemove []string `protobuf:"bytes,2,rep,name=request_headers_to_remove,json=requestHeadersToRemove,proto3" json:"request_headers_to_remove,omitempty"`
	// Specifies a list of HTTP headers that should be added to each response
	// handled by this route or host. For more information, including
	// details on header value syntax, see the
	// [Envoy documentation](https://www.envoyproxy.io/docs/envoy/latest/configuration/http_conn_man/headers#config-http-conn-man-headers-custom-request-headers) .
	ResponseHeadersToAdd []*HeaderValueOption `protobuf:"bytes,3,rep,name=response_headers_to_add,json=responseHeadersToAdd,proto3" json:"response_headers_to_add,omitempty"`
	// Specifies a list of HTTP headers that should be removed from each response
	// handled by this route or virtual host.
	ResponseHeadersToRemove []string `protobuf:"bytes,4,rep,name=response_headers_to_remove,json=responseHeadersToRemove,proto3" json:"response_headers_to_remove,omitempty"`
	XXX_NoUnkeyedLiteral    struct{} `json:"-"`
	XXX_unrecognized        []byte   `json:"-"`
	XXX_sizecache           int32    `json:"-"`
}

func (m *HeaderManipulation) Reset()         { *m = HeaderManipulation{} }
func (m *HeaderManipulation) String() string { return proto.CompactTextString(m) }
func (*HeaderManipulation) ProtoMessage()    {}
func (*HeaderManipulation) Descriptor() ([]byte, []int) {
	return fileDescriptor_fc0de64b70fd96e8, []int{0}
}
func (m *HeaderManipulation) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_HeaderManipulation.Unmarshal(m, b)
}
func (m *HeaderManipulation) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_HeaderManipulation.Marshal(b, m, deterministic)
}
func (m *HeaderManipulation) XXX_Merge(src proto.Message) {
	xxx_messageInfo_HeaderManipulation.Merge(m, src)
}
func (m *HeaderManipulation) XXX_Size() int {
	return xxx_messageInfo_HeaderManipulation.Size(m)
}
func (m *HeaderManipulation) XXX_DiscardUnknown() {
	xxx_messageInfo_HeaderManipulation.DiscardUnknown(m)
}

var xxx_messageInfo_HeaderManipulation proto.InternalMessageInfo

func (m *HeaderManipulation) GetRequestHeadersToAdd() []*HeaderValueOption {
	if m != nil {
		return m.RequestHeadersToAdd
	}
	return nil
}

func (m *HeaderManipulation) GetRequestHeadersToRemove() []string {
	if m != nil {
		return m.RequestHeadersToRemove
	}
	return nil
}

func (m *HeaderManipulation) GetResponseHeadersToAdd() []*HeaderValueOption {
	if m != nil {
		return m.ResponseHeadersToAdd
	}
	return nil
}

func (m *HeaderManipulation) GetResponseHeadersToRemove() []string {
	if m != nil {
		return m.ResponseHeadersToRemove
	}
	return nil
}

// Header name/value pair plus option to control append behavior.
type HeaderValueOption struct {
	// Header name/value pair that this option applies to.
	Header *HeaderValue `protobuf:"bytes,1,opt,name=header,proto3" json:"header,omitempty"`
	// Should the value be appended? If true (default), the value is appended to
	// existing values.
	Append               *types.BoolValue `protobuf:"bytes,2,opt,name=append,proto3" json:"append,omitempty"`
	XXX_NoUnkeyedLiteral struct{}         `json:"-"`
	XXX_unrecognized     []byte           `json:"-"`
	XXX_sizecache        int32            `json:"-"`
}

func (m *HeaderValueOption) Reset()         { *m = HeaderValueOption{} }
func (m *HeaderValueOption) String() string { return proto.CompactTextString(m) }
func (*HeaderValueOption) ProtoMessage()    {}
func (*HeaderValueOption) Descriptor() ([]byte, []int) {
	return fileDescriptor_fc0de64b70fd96e8, []int{1}
}
func (m *HeaderValueOption) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_HeaderValueOption.Unmarshal(m, b)
}
func (m *HeaderValueOption) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_HeaderValueOption.Marshal(b, m, deterministic)
}
func (m *HeaderValueOption) XXX_Merge(src proto.Message) {
	xxx_messageInfo_HeaderValueOption.Merge(m, src)
}
func (m *HeaderValueOption) XXX_Size() int {
	return xxx_messageInfo_HeaderValueOption.Size(m)
}
func (m *HeaderValueOption) XXX_DiscardUnknown() {
	xxx_messageInfo_HeaderValueOption.DiscardUnknown(m)
}

var xxx_messageInfo_HeaderValueOption proto.InternalMessageInfo

func (m *HeaderValueOption) GetHeader() *HeaderValue {
	if m != nil {
		return m.Header
	}
	return nil
}

func (m *HeaderValueOption) GetAppend() *types.BoolValue {
	if m != nil {
		return m.Append
	}
	return nil
}

// Header name/value pair.
type HeaderValue struct {
	// Header name.
	Key string `protobuf:"bytes,1,opt,name=key,proto3" json:"key,omitempty"`
	// Header value.
	Value                string   `protobuf:"bytes,2,opt,name=value,proto3" json:"value,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *HeaderValue) Reset()         { *m = HeaderValue{} }
func (m *HeaderValue) String() string { return proto.CompactTextString(m) }
func (*HeaderValue) ProtoMessage()    {}
func (*HeaderValue) Descriptor() ([]byte, []int) {
	return fileDescriptor_fc0de64b70fd96e8, []int{2}
}
func (m *HeaderValue) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_HeaderValue.Unmarshal(m, b)
}
func (m *HeaderValue) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_HeaderValue.Marshal(b, m, deterministic)
}
func (m *HeaderValue) XXX_Merge(src proto.Message) {
	xxx_messageInfo_HeaderValue.Merge(m, src)
}
func (m *HeaderValue) XXX_Size() int {
	return xxx_messageInfo_HeaderValue.Size(m)
}
func (m *HeaderValue) XXX_DiscardUnknown() {
	xxx_messageInfo_HeaderValue.DiscardUnknown(m)
}

var xxx_messageInfo_HeaderValue proto.InternalMessageInfo

func (m *HeaderValue) GetKey() string {
	if m != nil {
		return m.Key
	}
	return ""
}

func (m *HeaderValue) GetValue() string {
	if m != nil {
		return m.Value
	}
	return ""
}

func init() {
	proto.RegisterType((*HeaderManipulation)(nil), "headers.options.gloo.solo.io.HeaderManipulation")
	proto.RegisterType((*HeaderValueOption)(nil), "headers.options.gloo.solo.io.HeaderValueOption")
	proto.RegisterType((*HeaderValue)(nil), "headers.options.gloo.solo.io.HeaderValue")
}

func init() {
	proto.RegisterFile("github.com/solo-io/gloo/projects/gloo/api/v1/options/headers/headers.proto", fileDescriptor_fc0de64b70fd96e8)
}

var fileDescriptor_fc0de64b70fd96e8 = []byte{
	// 373 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0x9c, 0x92, 0xc1, 0x4a, 0xf3, 0x40,
	0x10, 0xc7, 0x49, 0xf3, 0x7d, 0x85, 0x6e, 0x2f, 0xba, 0x96, 0x36, 0x06, 0x29, 0xa5, 0xa7, 0x7a,
	0x70, 0x17, 0x2b, 0x1e, 0xc4, 0x8b, 0xed, 0x41, 0x44, 0x10, 0x21, 0x88, 0x07, 0x2f, 0x25, 0x6d,
	0xb6, 0xdb, 0xd8, 0x34, 0xb3, 0xee, 0x26, 0x15, 0x5f, 0xc1, 0x27, 0xf1, 0x99, 0x3c, 0xfa, 0x24,
	0xb2, 0xbb, 0x69, 0xd1, 0xb6, 0x4a, 0xf1, 0x94, 0x0c, 0x33, 0xff, 0xdf, 0xfc, 0x60, 0x16, 0x5d,
	0xf3, 0x38, 0x9b, 0xe4, 0x43, 0x32, 0x82, 0x19, 0x55, 0x90, 0xc0, 0x51, 0x0c, 0x94, 0x27, 0x00,
	0x54, 0x48, 0x78, 0x64, 0xa3, 0x4c, 0xd9, 0x2a, 0x14, 0x31, 0x9d, 0x1f, 0x53, 0x10, 0x59, 0x0c,
	0xa9, 0xa2, 0x13, 0x16, 0x46, 0x4c, 0x2e, 0xbf, 0x44, 0x48, 0xc8, 0x00, 0x1f, 0x2c, 0xca, 0x62,
	0x8c, 0xe8, 0x28, 0xd1, 0x54, 0x12, 0x83, 0x5f, 0xe3, 0xc0, 0xc1, 0x0c, 0x52, 0xfd, 0x67, 0x33,
	0x7e, 0x93, 0x03, 0xf0, 0x84, 0x51, 0x53, 0x0d, 0xf3, 0x31, 0x7d, 0x96, 0xa1, 0x10, 0x4b, 0x66,
	0xfb, 0xbd, 0x84, 0xf0, 0x95, 0xc1, 0xde, 0x84, 0x69, 0x2c, 0xf2, 0x24, 0xd4, 0x68, 0x1c, 0xa1,
	0xba, 0x64, 0x4f, 0x39, 0x53, 0xd9, 0xa0, 0x58, 0x3a, 0xc8, 0x60, 0x10, 0x46, 0x91, 0xe7, 0xb4,
	0xdc, 0x4e, 0xb5, 0x4b, 0xc9, 0x6f, 0x2e, 0xc4, 0x12, 0xef, 0xc3, 0x24, 0x67, 0xb7, 0xa6, 0x1f,
	0xec, 0x15, 0x38, 0xdb, 0x51, 0x77, 0xd0, 0x8b, 0x22, 0x7c, 0x86, 0xf6, 0x37, 0x6c, 0x91, 0x6c,
	0x06, 0x73, 0xe6, 0x95, 0x5a, 0x6e, 0xa7, 0x12, 0xd4, 0x57, 0x73, 0x81, 0xe9, 0xe2, 0x31, 0x6a,
	0x48, 0xa6, 0x04, 0xa4, 0x8a, 0xad, 0x1a, 0xba, 0x7f, 0x33, 0xac, 0x2d, 0x78, 0xdf, 0x14, 0xcf,
	0x91, 0xbf, 0x69, 0x4f, 0xe1, 0xf8, 0xcf, 0x38, 0x36, 0xd6, 0x92, 0x56, 0xb2, 0xfd, 0xea, 0xa0,
	0xdd, 0xb5, 0x45, 0xb8, 0x87, 0xca, 0x96, 0xe4, 0x39, 0x2d, 0xa7, 0x53, 0xed, 0x1e, 0x6e, 0x6d,
	0x1a, 0x14, 0x41, 0xdc, 0x45, 0x65, 0x7d, 0xc5, 0x34, 0xf2, 0x4a, 0x06, 0xe1, 0x13, 0x7b, 0x66,
	0xb2, 0x38, 0x33, 0xe9, 0x03, 0x24, 0x45, 0xc6, 0x4e, 0xb6, 0x4f, 0x51, 0xf5, 0x0b, 0x0a, 0xef,
	0x20, 0x77, 0xca, 0x5e, 0x8c, 0x42, 0x25, 0xd0, 0xbf, 0xb8, 0x86, 0xfe, 0xcf, 0x75, 0xcb, 0x30,
	0x2b, 0x81, 0x2d, 0xfa, 0x97, 0x6f, 0x1f, 0x4d, 0xe7, 0xe1, 0x62, 0xbb, 0x67, 0x2c, 0xa6, 0xfc,
	0x87, 0xa7, 0x3c, 0x2c, 0x1b, 0xb5, 0x93, 0xcf, 0x00, 0x00, 0x00, 0xff, 0xff, 0xfe, 0x18, 0x46,
	0x0b, 0x11, 0x03, 0x00, 0x00,
}

func (this *HeaderManipulation) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*HeaderManipulation)
	if !ok {
		that2, ok := that.(HeaderManipulation)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if len(this.RequestHeadersToAdd) != len(that1.RequestHeadersToAdd) {
		return false
	}
	for i := range this.RequestHeadersToAdd {
		if !this.RequestHeadersToAdd[i].Equal(that1.RequestHeadersToAdd[i]) {
			return false
		}
	}
	if len(this.RequestHeadersToRemove) != len(that1.RequestHeadersToRemove) {
		return false
	}
	for i := range this.RequestHeadersToRemove {
		if this.RequestHeadersToRemove[i] != that1.RequestHeadersToRemove[i] {
			return false
		}
	}
	if len(this.ResponseHeadersToAdd) != len(that1.ResponseHeadersToAdd) {
		return false
	}
	for i := range this.ResponseHeadersToAdd {
		if !this.ResponseHeadersToAdd[i].Equal(that1.ResponseHeadersToAdd[i]) {
			return false
		}
	}
	if len(this.ResponseHeadersToRemove) != len(that1.ResponseHeadersToRemove) {
		return false
	}
	for i := range this.ResponseHeadersToRemove {
		if this.ResponseHeadersToRemove[i] != that1.ResponseHeadersToRemove[i] {
			return false
		}
	}
	if !bytes.Equal(this.XXX_unrecognized, that1.XXX_unrecognized) {
		return false
	}
	return true
}
func (this *HeaderValueOption) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*HeaderValueOption)
	if !ok {
		that2, ok := that.(HeaderValueOption)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if !this.Header.Equal(that1.Header) {
		return false
	}
	if !this.Append.Equal(that1.Append) {
		return false
	}
	if !bytes.Equal(this.XXX_unrecognized, that1.XXX_unrecognized) {
		return false
	}
	return true
}
func (this *HeaderValue) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*HeaderValue)
	if !ok {
		that2, ok := that.(HeaderValue)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if this.Key != that1.Key {
		return false
	}
	if this.Value != that1.Value {
		return false
	}
	if !bytes.Equal(this.XXX_unrecognized, that1.XXX_unrecognized) {
		return false
	}
	return true
}
