// Code generated by protoc-gen-gogo. DO NOT EDIT.
// source: status.proto

package core

import (
	bytes "bytes"
	fmt "fmt"
	math "math"

	_ "github.com/gogo/protobuf/gogoproto"
	proto "github.com/gogo/protobuf/proto"
	types "github.com/gogo/protobuf/types"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.GoGoProtoPackageIsVersion3 // please upgrade the proto package

type Status_State int32

const (
	// Pending status indicates the resource has not yet been validated
	Status_Pending Status_State = 0
	// Accepted indicates the resource has been validated
	Status_Accepted Status_State = 1
	// Rejected indicates an invalid configuration by the user
	// Rejected resources may be propagated to the xDS server depending on their severity
	Status_Rejected Status_State = 2
	// Warning indicates a partially invalid configuration by the user
	// Resources with Warnings may be partially accepted by a controller, depending on the implementation
	Status_Warning Status_State = 3
)

var Status_State_name = map[int32]string{
	0: "Pending",
	1: "Accepted",
	2: "Rejected",
	3: "Warning",
}

var Status_State_value = map[string]int32{
	"Pending":  0,
	"Accepted": 1,
	"Rejected": 2,
	"Warning":  3,
}

func (x Status_State) String() string {
	return proto.EnumName(Status_State_name, int32(x))
}

func (Status_State) EnumDescriptor() ([]byte, []int) {
	return fileDescriptor_dfe4fce6682daf5b, []int{0, 0}
}

//*
// Status indicates whether a resource has been (in)validated by a reporter in the system.
// Statuses are meant to be read-only by users
type Status struct {
	// State is the enum indicating the state of the resource
	State Status_State `protobuf:"varint,1,opt,name=state,proto3,enum=core.solo.io.Status_State" json:"state,omitempty"`
	// Reason is a description of the error for Rejected resources. If the resource is pending or accepted, this field will be empty
	Reason string `protobuf:"bytes,2,opt,name=reason,proto3" json:"reason,omitempty"`
	// Reference to the reporter who wrote this status
	ReportedBy string `protobuf:"bytes,3,opt,name=reported_by,json=reportedBy,proto3" json:"reported_by,omitempty"`
	// Reference to statuses (by resource-ref string: "Kind.Namespace.Name") of subresources of the parent resource
	SubresourceStatuses map[string]*Status `protobuf:"bytes,4,rep,name=subresource_statuses,json=subresourceStatuses,proto3" json:"subresource_statuses,omitempty" protobuf_key:"bytes,1,opt,name=key,proto3" protobuf_val:"bytes,2,opt,name=value,proto3"`
	// Opaque details about status results
	Details              *types.Struct `protobuf:"bytes,5,opt,name=details,proto3" json:"details,omitempty"`
	XXX_NoUnkeyedLiteral struct{}      `json:"-"`
	XXX_unrecognized     []byte        `json:"-"`
	XXX_sizecache        int32         `json:"-"`
}

func (m *Status) Reset()         { *m = Status{} }
func (m *Status) String() string { return proto.CompactTextString(m) }
func (*Status) ProtoMessage()    {}
func (*Status) Descriptor() ([]byte, []int) {
	return fileDescriptor_dfe4fce6682daf5b, []int{0}
}
func (m *Status) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_Status.Unmarshal(m, b)
}
func (m *Status) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_Status.Marshal(b, m, deterministic)
}
func (m *Status) XXX_Merge(src proto.Message) {
	xxx_messageInfo_Status.Merge(m, src)
}
func (m *Status) XXX_Size() int {
	return xxx_messageInfo_Status.Size(m)
}
func (m *Status) XXX_DiscardUnknown() {
	xxx_messageInfo_Status.DiscardUnknown(m)
}

var xxx_messageInfo_Status proto.InternalMessageInfo

func (m *Status) GetState() Status_State {
	if m != nil {
		return m.State
	}
	return Status_Pending
}

func (m *Status) GetReason() string {
	if m != nil {
		return m.Reason
	}
	return ""
}

func (m *Status) GetReportedBy() string {
	if m != nil {
		return m.ReportedBy
	}
	return ""
}

func (m *Status) GetSubresourceStatuses() map[string]*Status {
	if m != nil {
		return m.SubresourceStatuses
	}
	return nil
}

func (m *Status) GetDetails() *types.Struct {
	if m != nil {
		return m.Details
	}
	return nil
}

func init() {
	proto.RegisterEnum("core.solo.io.Status_State", Status_State_name, Status_State_value)
	proto.RegisterType((*Status)(nil), "core.solo.io.Status")
	proto.RegisterMapType((map[string]*Status)(nil), "core.solo.io.Status.SubresourceStatusesEntry")
}

func init() { proto.RegisterFile("status.proto", fileDescriptor_dfe4fce6682daf5b) }

var fileDescriptor_dfe4fce6682daf5b = []byte{
	// 370 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0x74, 0x90, 0xdf, 0x6a, 0xdb, 0x30,
	0x18, 0xc5, 0xe7, 0x78, 0x4e, 0x16, 0x39, 0x8c, 0xa0, 0x85, 0xcd, 0x98, 0xb1, 0x99, 0x5c, 0x99,
	0x41, 0xa4, 0xc5, 0x63, 0x50, 0x5a, 0x7a, 0xd1, 0x40, 0xef, 0x8b, 0x73, 0x51, 0x28, 0x85, 0xd4,
	0x7f, 0xbe, 0xba, 0x6e, 0x5c, 0xcb, 0x48, 0x72, 0xc0, 0x0f, 0x54, 0xe8, 0x73, 0xf5, 0x49, 0x8a,
	0xa4, 0x98, 0x16, 0x9a, 0x5e, 0x49, 0xc7, 0xe7, 0xe7, 0xef, 0xd3, 0x39, 0x68, 0x22, 0x64, 0x22,
	0x5b, 0x41, 0x1a, 0xce, 0x24, 0xc3, 0x93, 0x8c, 0x71, 0x20, 0x82, 0x55, 0x8c, 0x94, 0xcc, 0x9f,
	0x15, 0xac, 0x60, 0xda, 0xa0, 0xea, 0x66, 0x18, 0xff, 0x67, 0xc1, 0x58, 0x51, 0x01, 0xd5, 0x2a,
	0x6d, 0x6f, 0xa9, 0x90, 0xbc, 0xcd, 0xa4, 0x71, 0xe7, 0x8f, 0x36, 0x1a, 0xae, 0xf5, 0x48, 0xfc,
	0x17, 0x39, 0x6a, 0x38, 0x78, 0x56, 0x60, 0x85, 0x5f, 0x23, 0x9f, 0xbc, 0x1d, 0x4e, 0x0c, 0xa4,
	0x0f, 0x88, 0x0d, 0x88, 0xbf, 0xa3, 0x21, 0x87, 0x44, 0xb0, 0xda, 0x1b, 0x04, 0x56, 0x38, 0x8e,
	0xf7, 0x0a, 0xff, 0x46, 0x2e, 0x87, 0x86, 0x71, 0x09, 0xf9, 0x26, 0xed, 0x3c, 0x5b, 0x9b, 0xa8,
	0xff, 0xb4, 0xea, 0xf0, 0x0d, 0x9a, 0x89, 0x36, 0xe5, 0x20, 0x58, 0xcb, 0x33, 0xd8, 0x98, 0x4c,
	0x20, 0xbc, 0xcf, 0x81, 0x1d, 0xba, 0xd1, 0xe2, 0xf0, 0xe6, 0xd7, 0x1f, 0xd6, 0x7b, 0xfe, 0xbc,
	0x96, 0xbc, 0x8b, 0xbf, 0x89, 0xf7, 0x0e, 0x5e, 0xa2, 0x51, 0x0e, 0x32, 0x29, 0x2b, 0xe1, 0x39,
	0x81, 0x15, 0xba, 0xd1, 0x0f, 0x62, 0x7a, 0x20, 0x7d, 0x0f, 0x64, 0xad, 0x7b, 0x88, 0x7b, 0xce,
	0xbf, 0x46, 0xde, 0x47, 0x3b, 0xf0, 0x14, 0xd9, 0x5b, 0xe8, 0x74, 0x33, 0xe3, 0x58, 0x5d, 0xf1,
	0x1f, 0xe4, 0xec, 0x92, 0xaa, 0x05, 0x1d, 0xdd, 0x8d, 0x66, 0x87, 0xde, 0x1c, 0x1b, 0xe4, 0x78,
	0x70, 0x64, 0xcd, 0x4f, 0x91, 0xa3, 0xbb, 0xc3, 0x2e, 0x1a, 0x5d, 0x40, 0x9d, 0x97, 0x75, 0x31,
	0xfd, 0x84, 0x27, 0xe8, 0xcb, 0x59, 0x96, 0x41, 0x23, 0x21, 0x9f, 0x5a, 0x4a, 0xc5, 0x70, 0x0f,
	0x99, 0x52, 0x03, 0x05, 0x5e, 0x26, 0xbc, 0x56, 0xa0, 0xbd, 0x3a, 0x79, 0x7a, 0xfe, 0x65, 0x5d,
	0xfd, 0x2f, 0x4a, 0x79, 0xd7, 0xa6, 0x24, 0x63, 0x0f, 0x54, 0xad, 0x5a, 0x94, 0xcc, 0x9c, 0xdb,
	0x52, 0xd2, 0x66, 0x5b, 0xd0, 0xa4, 0x29, 0xe9, 0x6e, 0x49, 0xfb, 0x10, 0x82, 0xaa, 0x57, 0xa5,
	0x43, 0x9d, 0xf9, 0xdf, 0x4b, 0x00, 0x00, 0x00, 0xff, 0xff, 0xce, 0xf2, 0xdf, 0x13, 0x3d, 0x02,
	0x00, 0x00,
}

func (this *Status) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*Status)
	if !ok {
		that2, ok := that.(Status)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if this.State != that1.State {
		return false
	}
	if this.Reason != that1.Reason {
		return false
	}
	if this.ReportedBy != that1.ReportedBy {
		return false
	}
	if len(this.SubresourceStatuses) != len(that1.SubresourceStatuses) {
		return false
	}
	for i := range this.SubresourceStatuses {
		if !this.SubresourceStatuses[i].Equal(that1.SubresourceStatuses[i]) {
			return false
		}
	}
	if !this.Details.Equal(that1.Details) {
		return false
	}
	if !bytes.Equal(this.XXX_unrecognized, that1.XXX_unrecognized) {
		return false
	}
	return true
}
